%define name	nspluginwrapper
%define version	0.9.90.1
%define release	1

# define 32-bit arch of multiarch platforms
%define arch_32 %{nil}
%ifarch x86_64
%define arch_32 i386
%endif
%ifarch ppc64
%define arch_32 ppc
%endif
%ifarch sparc64
%define arch_32 sparc
%endif

# define target architecture plugins we want to support
%define target_arch i386

# define nspluginswrapper libdir (invariant, including libdir)
%define pkglibdir %{_prefix}/lib/%{name}

# define mozilla plugin dir
%define plugindir %{_libdir}/mozilla/plugins

# define to build a biarch package
%define build_biarch		0
%{expand: %{?_with_biarch:	%%global build_biarch 1}}
%{expand: %{?_without_biarch:	%%global build_biarch 0}}

# XXX only useful to grab information, other libs are needed
%define build_runtime 0

Summary:	A compatibility layer for Netscape 4 plugins
Name:		%{name}
Version:	%{version}
Release:	%{release}
Source0:	%{name}-%{version}.tar.bz2
License:	GPL
Group:		Networking/WWW
Url:		http://www.gibix.net/projects/nspluginwrapper/
BuildRequires:	gtk+2-devel
Provides:	%{name}-%{_arch} = %{version}-%{release}
Requires:	%{name}-%{target_arch} = %{version}-%{release}
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
nspluginwrapper makes it possible to use Netscape 4 compatible plugins
compiled for %{target_arch} into Mozilla for another architecture, e.g. x86_64.

This package consists in:
  * npviewer: the plugin viewer
  * npwrapper.so: the browser-side plugin
  * nspluginwrapper: a tool to manage plugins installation and update

%if %{build_biarch}
%package %{target_arch}
Summary:	A viewer for %{target_arch} compiled Netscape 4 plugins
Group:		Networking/WWW
BuildRequires:	/usr/bin/linux32

%description %{target_arch}
nspluginwrapper makes it possible to use Netscape 4 compatible plugins
compiled for %{target_arch} into Mozilla for another architecture, e.g. x86_64.

This package consists in:
  * npviewer: the plugin viewer
  * npwrapper.so: the browser-side plugin
  * nspluginwrapper: a tool to manage plugins installation and update

This package provides the npviewer program for %{target_arch}.
%endif

%package runtime
Summary:	nspluginwrapper self-contained runtime
License:	GPL/LGPL/MIT
Group:		System/Libraries
AutoReq:	no
AutoProv:	no
Provides:	%{name}-runtime-%{_arch} = %{version}-%{release}

%description runtime
This packages contains enough of %{target_arch} runtime to execute the
Netscape 4 plugin viewer. It is mostly useful for emulated execution
with QEMU for example.

Note that you may need other %{target_arch} libraries depending on the
requirements of the plugin you intend to use.

%prep
%setup -q

%build
export CFLAGS="$RPM_OPT_FLAGS"
export CXXFLAGS="$RPM_OPT_FLAGS"

mkdir build-%{_arch}-linux
pushd build-%{_arch}-linux
../configure --prefix=%{_prefix}
%make
popd

%if %{build_biarch}
mkdir build-%{target_arch}-linux
pushd build-%{target_arch}-linux
linux32 ../configure --prefix=%{_prefix}
linux32 %make npviewer.bin
popd
%endif

%install
rm -rf $RPM_BUILD_ROOT

make -C build-%{_arch}-linux install DESTDIR=$RPM_BUILD_ROOT

%if %{build_biarch}
make -C build-%{target_arch}-linux install.viewer DESTDIR=$RPM_BUILD_ROOT
%endif

%if %{build_runtime}
make -C build-%{_arch}-linux install.viewerlibs DESTDIR=$RPM_BUILD_ROOT
%endif

mkdir -p $RPM_BUILD_ROOT%{plugindir}
ln -s %{pkglibdir}/%{_arch}/npwrapper.so $RPM_BUILD_ROOT%{plugindir}/npwrapper.so

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ $1 = 1 ]; then
  ln -s %{pkglibdir}/%{_arch}/npconfig %{_bindir}/%{name}
  %{_bindir}/%{name} -v -a -i
else
  %{_bindir}/%{name} -v -a -u
fi

%preun
if [ $1 = 0 ]; then
  %{_bindir}/%{name} -v -a -r
  rm -f %{_bindir}/%{name}
fi

%files
%defattr(-,root,root)
%doc README COPYING NEWS
%{plugindir}/npwrapper.so
%dir %{pkglibdir}
%{pkglibdir}/npviewer
%{pkglibdir}/mkruntime
%dir %{pkglibdir}/%{_arch}
%{pkglibdir}/%{_arch}/npconfig
%{pkglibdir}/%{_arch}/npviewer.bin
%{pkglibdir}/%{_arch}/npwrapper.so

%if %{build_biarch}
%files %{target_arch}
%defattr(-,root,root)
%dir %{pkglibdir}/%{target_arch}
%{pkglibdir}/%{target_arch}/npviewer.bin
%endif

%if %{build_runtime}
%files runtime
%defattr(-,root,root)
%dir %{pkglibdir}/%{_arch}/runtime
%{pkglibdir}/%{_arch}/runtime/*
%endif

%changelog
* Sun Jun  4 2006 Gwenole Beauchesne <gb.public@free.fr> 0.9.90.1-1
- relicense under GPL
- don't use QEMU on IA-64
- handle SuSE Linux Mozilla paths
- portability fixes to non-Linux platforms

* Tue Oct 25 2005 Gwenole Beauchesne <gb.public@free.fr> 0.9.90-1
- first public beta version
